#include <ccar.h>


CRoad       **initroads (int   &aNum);
CCarMask    **initmasks (int   &aNum);
CPoint<float> initstart (float &aKof, int &aBk);

void main()
{
int   aRoadNum = 0;
int   aMaskNum = 0;
float aKof     = 0;
int   aBk      = BLACK;
CRoad    **road 	= initroads (aRoadNum);
CCarMask **mask 	= initmasks (aMaskNum);
CPoint<float> start = initstart (aKof, aBk);

CGBDD manager (aRoadNum, road, aMaskNum, mask, start, aKof,
									  new CBGIScreen, aBk);
manager.run();
}

//------------------reads-road.inf-from-current-dir-and-use-it-------------\\
//ENTRY:  ssilka  na number of roads
//RETURN: pointer na massiv dorog
CRoad **initroads (int &aNum)
{
FILE *f = fopen ("roads.inf", "r");
if (!f) terminate ("Can't find 'roads.inf'\n");
if (fscanf (f, "%d", &aNum) == EOF) terminate ("Bad date in 'roads.inf'\n");
CRoad **mass = (CRoad **) malloc (sizeof (CRoad **) * aNum);
assert (mass);
char tmp[32];
for (int i = 0; i < aNum; i++)
	{
	fscanf (f, "%s", tmp);
	FILE *ftmp = fopen (tmp, "r");
	if (ferror (ftmp)) { fclose (ftmp); continue; }
	fclose (ftmp);
	mass[i] = new CRoad (tmp);
	}
fclose (f);
return mass;
}

//------------------reads-car.inf-from-current-dir-and-use-it--------------\\
//ENTRY:  ssilka  na number of cars
//RETURN: pointer na massiv of cars
CCarMask **initmasks (int &aNum)
{
FILE *f = fopen ("cars.inf", "r");
if (!f) terminate ("Can't find 'cars.inf'\n");
if (fscanf (f, "%d", &aNum) == EOF) terminate ("Bad date in 'cars.inf'\n");
CCarMask **mass = (CCarMask **) malloc (sizeof (CCarMask **) * aNum);
assert (mass);
char tmp[32];
for (int i = 0; i < aNum; i++)
	{
	fscanf (f, "%s", tmp);
	FILE *ftmp = fopen (tmp, "r");
	if (ferror (ftmp)) { fclose (ftmp); continue; }
	fclose (ftmp);
	mass[i] = new CCarMask (tmp);
	}
fclose (f);
return mass;
}

//------------------reads-main.inf-from-current-dir-and-use-it-------------\\
//ENTRY:  ssilki  na koficent of speed and na backcolor
//RETURN: Start point
CPoint<float> initstart (float &aKof, int &aBk)
{
FILE *f = fopen ("main.inf", "r");
if (!f) terminate ("Can't find 'main.inf'\n");
CPoint<float> result;
if (fscanf (f, "%f", &(result.x)) == EOF)
	terminate ("Bad date in 'main.inf'\n");
if (fscanf (f, "%f", &(result.y)) == EOF)
	terminate ("Bad date in 'main.inf'\n");
if (fscanf (f, "%f", &aKof) == EOF)
	terminate ("Bad date in 'main.inf'\n");
if (fscanf (f, "%d", &aBk) == EOF)
	terminate ("Bad date in 'main.inf'\n");

fclose (f);
return result;
}