#include <assert.h>

#include <crect.h>
#include <cbgi.h>
#include <ctext.h>
#include <cmouse.h>
#include <cwmm.h>
#include <cstdolw.h>
#include <cbutton.h>
#include <cpalitra.h>
#include <cmask.h>

#define				NUMBER_OF_DOTS   		225

//----HANDLER--EVENTS-FUNCTIONS--------------------------------------------\\
void CLOSE_NAVIGATOR 		 (CSTDOLW *p);
void CLOSE_EDITOR   		 (CSTDOLW *p);

void NAVIGATOR_BUTTON_NEWCAR (CButton *b);
void NAVIGATOR_BUTTON_OPEN   (CButton *b);
void NAVIGATOR_BUTTON_EXIT   (CButton *b);

void EDITOR_BUTTON_CLOSE     (CButton *p);
void EDITOR_BUTTON_OPEN      (CButton *p);
void EDITOR_BUTTON_SAVE      (CButton *p);
void EDITOR_BUTTON_CLEAR     (CButton *p);
void EDITOR_PALITRA_CHANGE   (CPalitra *b);

void WIN_SAVER_SAVE          (CButton *p);
void WIN_SAVER_CLOSE         (CButton *p);

void WIN_OPEN_OPEN           (CButton *p);
void WIN_OPEN_CLOSE          (CButton *p);

void WIN_MSG_CLOSE           (CButton *p);
void WIN_MSG_USE             (char *aCap);
//-----------------WINDOWS-------------------------------------------------\\
CSTDOLW *win_navigator = new CSTDOLW (CRect<int> (10, 10, 150, 300),
									  "Car editor:", CLOSE_NAVIGATOR);

CSTDOLW *win_editor    = new CSTDOLW (CRect<int> (10, 10, 350, 390),
									 "Editor:", CLOSE_EDITOR, CLOSE);

CSTDOLW *win_saver     = new CSTDOLW (CRect<int> (370, 10, 250, 200),
											"Save as:", NULL, CLOSE);

CSTDOLW *win_open      = new CSTDOLW (CRect<int> (370, 10, 250, 200),
										  "Open file:", NULL, CLOSE);

CSTDOLW *win_msg       = new CSTDOLW (CRect<int> (370, 220, 250, 120),
											 "Message:", NULL, CLOSE);

CMask   *aMask         = NULL;
CText   *aSText   	   = NULL;
CText   *aOText        = NULL;
CLabel  *aMsg          = NULL;

void initallwindows();

void main()
{
CWMM *wmm  = new CWMM (new CBGIScreen, new CMouse);
assert (wmm);
assert (win_navigator);
assert (win_editor);
assert (win_saver);
assert (win_open);
assert (win_msg);

initallwindows();

assert (aMask);
assert (aSText);
assert (aOText);
assert (aMsg);

wmm->add (win_navigator);
wmm->add (win_editor);
wmm->add (win_saver);
wmm->add (win_open);
wmm->add (win_msg);

wmm->run();
delete wmm;
}

//--------------------init-windows-----------------------------------------\\
void initallwindows()
{
win_navigator->add (new CButton (CRect<int> (10, 40, 100, 20), "New car",
												  NAVIGATOR_BUTTON_NEWCAR));

win_navigator->add (new CButton (CRect<int> (10, 70, 100, 20), "Open car...",
													 NAVIGATOR_BUTTON_OPEN));

win_navigator->add (new CButton (CRect<int> (10, 265, 100, 20), "Exit",
											   NAVIGATOR_BUTTON_EXIT));

win_editor->add (new CPalitra (CRect<int> (10, 30, 288, 20), 16,
										   EDITOR_PALITRA_CHANGE));

aMask = (CMask *) win_editor->add (new CMask (CRect<int>  (10, 60, 255, 255),
											 CPoint<int> (300, 60), 15, 15));

win_editor->add (new CButton  (CRect<int> (120, 360, 100, 20), "Close",
												EDITOR_BUTTON_CLOSE));

win_editor->add (new CButton  (CRect<int> (10, 330, 100, 20), "Open file...",
												EDITOR_BUTTON_OPEN));

win_editor->add (new CButton  (CRect<int> (10, 360, 100, 20), "Save as...",
												EDITOR_BUTTON_SAVE));

win_editor->add (new CButton  (CRect<int> (230, 360, 100, 20), "Clear",
												EDITOR_BUTTON_CLEAR));


aSText = (CText *) win_saver->add (new CText (CRect<int> (10, 25, 200, 20),
														"cars\\car00.car"));

win_saver->add (new CButton (CRect<int> (10, 170, 100, 20), "Save",
												WIN_SAVER_SAVE));

win_saver->add (new CButton (CRect<int> (120, 170, 100, 20), "Cancel",
													WIN_SAVER_CLOSE));

win_open->add (new CButton (CRect<int> (10, 170, 100, 20), "Open",
												  WIN_OPEN_OPEN));

win_open->add (new CButton (CRect<int> (120, 170, 100, 20), "Cancel",
													WIN_OPEN_CLOSE));

aOText = (CText *) win_open->add (new CText (CRect<int> (10, 25, 200, 20),
													  "cars\\car00.car"));

aMsg = (CLabel *) win_msg->add (new CLabel (CRect<int> (10, 40, 220, 20)));

win_msg->add (new CButton (CRect<int> (120, 80, 100, 20), "Ok",
												WIN_MSG_CLOSE));
}
//-------------------------EVENT-FUNCTIONS---------------------------------\\
void CLOSE_NAVIGATOR (CSTDOLW *p)
{
p->parent()->close();
}

void CLOSE_EDITOR (CSTDOLW *p)
{
p->parent()->closewindow (win_editor);
p->parent()->openwindow  (win_navigator);
}

void NAVIGATOR_BUTTON_NEWCAR (CButton *b)
{
b->parent()->parent()->closewindow (win_navigator);
b->parent()->parent()->openwindow  (win_editor);
}

void NAVIGATOR_BUTTON_EXIT (CButton *b)
{
b->parent()->close();
}

void NAVIGATOR_BUTTON_OPEN (CButton *b)
{
b++;
if (win_saver->status() == OPEN) win_saver->close();
win_open->open();
}

void EDITOR_BUTTON_CLOSE (CButton *b)
{
b->parent()->close();
}

void EDITOR_PALITRA_CHANGE (CPalitra *p)
{
aMask->setcolor (p->getcolor());
}

void EDITOR_BUTTON_OPEN (CButton *p)
{
p++;
if (win_saver->status() == OPEN) win_saver->close();
win_open->open();
}


void EDITOR_BUTTON_SAVE (CButton *p)
{
p++;
if (win_open->status() == OPEN) win_open->close();
win_saver->open();
}

void EDITOR_BUTTON_CLEAR (CButton *p)
{
p++;
aMask->setarrey (NULL);
}

void WIN_SAVER_SAVE (CButton *p)
{
FILE *f = fopen (aSText->text(), "w");
if (!f) { WIN_MSG_USE ("Can't open this file."); return; }
fprintf (f, "CCar ");
for (int i = 0; i < NUMBER_OF_DOTS; i++)
	fprintf (f, "%d ", * (aMask->getarrey() + i));
fclose (f);
p->parent()->close();
}


void WIN_SAVER_CLOSE (CButton *p)
{
p->parent()->close();
}

void WIN_MSG_CLOSE (CButton *p)
{
p->parent()->close();
}

void WIN_OPEN_OPEN (CButton *p)
{

FILE *f = fopen (aOText->text(), "r");
char tmp[10];
if (!f) { WIN_MSG_USE ("Can't open this file."); return; }
if (fscanf (f, "%s", tmp) == EOF || strcmp (tmp, "CCar"))
	{
	WIN_MSG_USE ("Bad file format.");
	return;
	}
int aMaskMass [NUMBER_OF_DOTS];
for (int i = 0; i < NUMBER_OF_DOTS; i++) fscanf (f, "%d", &aMaskMass[i]);
if (win_navigator->status() == OPEN)
	p->parent()->parent()->closewindow (win_navigator);
if (win_editor->status()    != OPEN) win_editor->open();
aMask->setarrey (aMaskMass);
fclose (f);
win_open->close();
}

void WIN_OPEN_CLOSE (CButton *p)
{
p->parent()->close();
}

void WIN_MSG_USE (char *aCap)
{
if (win_msg->status() != OPEN) win_msg->open();
aMsg->caption (aCap);
}