#ifndef __CCARMASK_H__
#define __CCARMASK_H__

#include <stdlib.h>
#include <conio.h>
#include <assert.h>
#include <string.h>
#include <stdio.h>

#include <cmath.h>
#include <mathadd.h>
#include <crect.h>
#include <cbgi.h>

#define 			HORIZ_DOT			15
#define 			VERT_DOT			15
#define				HIDE                0
#define				DRAW                1

class CCarMask
{
private:
				int  myLong;
				int *myMask;
				virtual void myLoad (char *file);
public:
				CCarMask (int *aMass);
				CCarMask (char *file);
				CCarMask ();
				virtual ~CCarMask();

				virtual void draw (CPoint<float> aLoc, int aParam, int aBk);
};
//----------------------------------CONSTURCTORS--------------------------\\
CCarMask::CCarMask (int *aMass)
{
myLong = VERT_DOT * HORIZ_DOT;
myMask = (int *) malloc (sizeof (int) * myLong);
assert (myMask);
for (int i = 0; i < myLong; i++) myMask[i] = aMass[i];
}

CCarMask::CCarMask (char *file)
{
myLong = VERT_DOT * HORIZ_DOT;
myMask = (int *) malloc (sizeof (int) * myLong);
myLoad (file);
}

CCarMask::CCarMask()
{
}

CCarMask::~CCarMask ()
{
delete myMask;
}


//----------------------------------FUNCTIONS-----------------------------\\
//ENTRY: path to file;
//EXIT:  void;
void CCarMask::myLoad (char *file)
{
FILE *f = fopen (file, "r");
if (f == NULL) terminate ("Can't find file\n");
char tmp[10];
if (fscanf (f, "%s", tmp) == EOF) terminate ("Bad data\n");
if (strcmp (tmp, "CCar")) terminate ("Unknow format\n");
for (int i = 0; i < myLong; i++) fscanf (f, "%d", &myMask[i]);
fclose (f);
}

//ENTRY: location, degree, param (HIDE or DRAW), backcolor;
//EXIT:  void;
void CCarMask::draw (CPoint<float> aLoc, int aParam, int aBk)
{
int aCol = aBk;
int x, y;
double c, d;
for (int i = 0; i < myLong; i++)
	{
	x = (i % HORIZ_DOT) - HORIZ_DOT / 2;
	y = (i / HORIZ_DOT) - VERT_DOT / 2;
	c = hypot (x, y);
	d = LineRad (0, 0, x, y) + (M_PI / 2);
	if (myMask[i] != NON)
		{
		if (aParam != HIDE) aCol = myMask[i];
		putpixel (aLoc.x + roundoff (c * cos(d + aLoc.z)),
				  aLoc.y + roundoff (c * sin(d + aLoc.z)), aCol);
		}
	}
}

#endif