#ifndef __FORMATS_H_
#define __FORMATS_H_
//-------------------------FORMATS-----------------------------------------\\
const char *formatStr (int)    					{ return "%d";  }
const char *formatStr (unsigned int)	    	{ return "%u";  }
const char *formatStr (long int) 				{ return "%ld";  }
const char *formatStr (short int)  				{ return "%hd";  }
const char *formatStr (float) 	 				{ return "%lf";  }
const char *formatStr (double) 					{ return "%lf"; }
const char *formatStr (long double) 			{ return "%lf"; }
const char *formatStr (char*)  					{ return "%s";  }
const char *formatStr (char)  					{ return "%d";  }

const char *typeStr (int)    					{ return "int";  }
const char *typeStr (unsigned int)  		  	{ return "unsigned int";  }
const char *typeStr (long int) 					{ return "long int";  }
const char *typeStr (short int)			  		{ return "short int";  }
const char *typeStr (float)  					{ return "float";  }
const char *typeStr (double) 					{ return "double"; }
const char *typeStr (long double) 				{ return "long double"; }
const char *typeStr (char*)  					{ return "char*";  }
const char *typeStr (char)  					{ return "char";  }

//-----------------CPoint--------------------------------------------------\\
template <class C>
class CPoint;

template <class C>
const char *typeOf (const CPoint<C>&)	 	     		 { return "CPoint<NewType>";}

const char *typeOf (const CPoint<int>&)  			 { return "CPoint<int>"; }
const char *typeOf (const CPoint<long int>&)	 	 	 { return "CPoint<long int>";}
const char *typeOf (const CPoint<short int>&)	 	 { return "CPoint<short int>";}
const char *typeOf (const CPoint<double>&)	 		 { return "CPoint<double>";}
const char *typeOf (const CPoint<long double>&)		 { return "CPoint<long double>";}
const char *typeOf (const CPoint<float>& )  	 		 { return "CPoint<float>"; }
const char *typeOf (const CPoint<char>& )  	 		 { return "CPoint<char>"; }

//-----------------CRect---------------------------------------------------\\
template <class C>
class CRect;

template <class C>
const char *typeOf (const CRect<C>&)	 	    	 	 { return "CRect<NewType>";}

const char *typeOf (const CRect<int>&)	 	 	 	 { return "CRect<int>";}
const char *typeOf (const CRect<long int>&)	 	 	 { return "CRect<long int>";}
const char *typeOf (const CRect<short int>&)	 	 	 { return "CRect<short int>";}
const char *typeOf (const CRect<double>&)	 	 		 { return "CRect<double>";}
const char *typeOf (const CRect<long double>&) 		 { return "CRect<long double>";}
const char *typeOf (const CRect<float>& )  	 		 { return "CRect<float>"; }
const char *typeOf (const CRect<char>& )  	 		 { return "CRect<char>"; }

#endif
