#ifndef  _CLABEL_H
#define  _CLABEL_H

#include <cwindow.h>

#define	LABEL_CAPTION_LONG			32

class CLabel: public CWindow
{
protected:		char myCaption[LABEL_CAPTION_LONG];
				CScreen *myDc;

				int myColor;
				int myFont;
				int myFontSize;
				int myFontColor;

				void (*myMsP)(CPoint<int> aLoc, CLabel *l);

				virtual void outtext();
public:
				CLabel (CRect<int> aLoc, char *aCaption = "Label",
						int aColor = LIGHTGRAY, int aFontColor   = BLACK,
						int aFont  = DEFAULT_FONT, int aFontSize = 1,
						void (*aMsP)(CPoint<int> aLoc, CLabel *l) = NULL);

				CLabel ();
				virtual ~CLabel();

				virtual void dc (CScreen *aDc);
				virtual void status  (int aStat);

				virtual void draw();
				virtual void firstdraw();

				virtual void caption   (char *aCap);
				virtual char *caption  ();
				virtual void color     (int aColor);
				virtual int  color     ();
				virtual void fontcolor (int aColor);
				virtual int  fontcolor ();
				virtual void font      (int aFont);
				virtual int  font	   ();
				virtual void fontsize  (int aSize);
				virtual int  fontsize  ();

				virtual void getFocus ();
				virtual void lostFocus();
				virtual void onMouse  (CPoint<int> aLoc);
				virtual void offMouse ();
				virtual void onKbhit  (int aKey);
				virtual void viewport ();
};
//----------------CONSTRUCTORS----------------------------------------------
CLabel::CLabel (CRect<int> aLoc, char *aCaption, int aColor,
					int aFontColor, int aFont, int aFontSize,
					void (*aMsP)(CPoint<int> aLoc, CLabel *l))
{
myEnableFocus = FALSE;
myColor    	  = aColor;
myLoc 		  = aLoc;
myFontColor   = aFontColor;
myFont        = aFont;
myFontSize	  = aFontSize;
myMsP  		  = aMsP;
myDc 		  = NULL;
myPar 	      = NULL;
strncpy (myCaption, aCaption, LABEL_CAPTION_LONG);
}

CLabel::CLabel()
{
myEnableFocus = FALSE;
myColor       = LIGHTGRAY;
myFontColor   = BLACK;
myFont        = DEFAULT_FONT;
myFontSize    = 1;
myPar 	      = NULL;
myDc 	      = NULL;
myMsP		  = NULL;
strncpy (myCaption, "Button", LABEL_CAPTION_LONG);
}

CLabel::~CLabel()
{
}

//---------------------------------------------------------------------------
void CLabel::status (int aStat)
{
myStatus = aStat;
draw();
if (myStatus == HIDE) parent()->nextFocus();
}

void CLabel::outtext()
{
if (!myDc) return;
viewport();
myDc->addviewport (myLoc);
myDc->textstyle (DEFAULT_FONT, 1);
switch (myStatus)
	{
	case HIDE:
		myDc->text (CPoint<int> (4, 4), myCaption,  LIGHTGRAY);		 break;
	case PRESS:
		myDc->text (CPoint<int> (4, 4), myCaption,  myFontColor);	 break;
	case UNPRESS:
		myDc->text (CPoint<int> (4, 4), myCaption,  myFontColor); 	 break;
	case DISABLE:
		myDc->text (CPoint<int> (4, 4), myCaption, DARKGRAY, WHITE); break;
	}
}

void CLabel::draw()
{
if (!myDc) return;
myMouse->hide();
viewport();
if (myStatus != HIDE && myColor != NON) myDc->rect (myLoc, myColor, myColor);
outtext();
myMouse->show();
}

void CLabel::firstdraw()
{
myDc->font (myFont);
myDc->fontsize (myFontSize);
draw();
}

void CLabel::caption (char *aCap)
{
strncpy (myCaption, aCap, LABEL_CAPTION_LONG);
draw();
}

char *CLabel::caption()
{
return myCaption;
}

//---------------------------------------------------------------------------
void CLabel::getFocus()
{
}

void CLabel::lostFocus()
{
}

//---------------------------------------------------------------------------
void CLabel::onMouse (CPoint<int> aLoc)
{
if (myMsP) (*myMsP)(aLoc, this);
}

void CLabel::offMouse ()
{
}

void CLabel::viewport()
{
if (myPar) myPar->viewport();
}

//---------------------------------------------------------------------------
void CLabel::onKbhit (int aKey)
{
aKey++;
}

//---------------------------------------------------------------------------
void CLabel::dc (CScreen *aDc)
{
myDc = aDc;
}
//---------------------------------------------------------------------------
void CLabel::color (int aColor)
{
myColor = aColor;
draw();
}

int CLabel::color()
{
return myColor;
}

void CLabel::fontcolor (int aColor)
{
myFontColor = aColor;
draw();
}

int CLabel::fontcolor()
{
return myFontColor;
}

void CLabel::font (int aFont)
{
myDc->font (aFont);
draw();
}

int  CLabel::font()
{
return myDc->font();
}

void CLabel::fontsize (int aSize)
{
myDc->fontsize (aSize);
draw();
}

int  CLabel::fontsize()
{
return myDc->fontsize();
}

#endif
//---------------------------------------------------------------------------