#ifndef __MOUSE_H_
#define __MOUSE_H_

#include <stdio.h>
#include <dos.h>

#include <defines.h>
#include <crect.h>

#define		LEFTB		1
#define		RIGHTB		2
//--------------------CLASS----------CCURSOR--------------------------------
class CCursor
{
private:    int myMass[32];
			CPoint<int> myHot;

public:
//------------------------------CONSTRUCTORS--------------------------------
			CCursor (int aMass[32], CPoint<int> aHot);
			CCursor (int aMass[32]);
			CCursor();
//-----------OPERATORS------------------------------------------------------
			CCursor operator = (CCursor aCur);
//-----------FUNCTIONS------------------------------------------------------
			CPoint<int> hotspot () const    { return	myHot;}
			void hotspot (CPoint<int> aHot) { myHot = aHot;   }
			int* mask ()					{ return myMass; }

			void mask (int aMass[32]);
			int save (char *aFile);
			int load (char *aFile);
};
//--------------------------------------------------------------------------
CCursor::CCursor (int aMass[32], CPoint<int> aHot): myHot (aHot)
{
for (int i = 0; i < 32; i++) myMass[i] = aMass[i];
}

CCursor::CCursor (int aMass[32]): myHot()
{
for (int i = 0; i < 32; i++) myMass[i] = aMass[i];
}

CCursor::CCursor(): myHot()
{
for (int i = 0; i < 32; i++) myMass[i] = 0;
}

CCursor CCursor::operator = (CCursor aCur)
{
myHot = aCur.myHot;
for (int i = 0; i < 32; i++) myMass[i] = aCur.myMass[i];
return *this;
}

void CCursor::mask (int aMass[32])
{
for (int i = 0; i < 32; i++) myMass[i] = aMass[i];
}

int CCursor::save (char *aFile)
{
FILE *file;
if ((file = fopen (aFile, "w")) == NULL) return FALSE;
for (int i = 0; i < 32; i++) fprintf (file, "%x\n", myMass[i]);
fprintf (file, "%d\n", myHot.x);
fprintf (file, "%d\n", myHot.y);
fclose (file);
return TRUE;
}
int CCursor::load (char *aFile)
{
FILE *file;
if ((file = fopen (aFile, "r")) == NULL) return FALSE;
for (int i = 0; i < 32; i++) fscanf (file, "%x\n", &myMass[i]);
fscanf (file, "%d\n", &myHot.x);
fscanf (file, "%d\n", &myHot.y);
fclose (file);
return TRUE;
}

//--------------------CLASS----------CMOUSE---------------------------------
class CMouse
{
private: 		int oldButtons;
				int newButtons;
				CPoint<int> oldLoc;
				CPoint<int> msLoc;

				void myAsk ();

public:         CMouse();
//-----------------------------MAIN----------------------------------------\\
				int init();
				int ask ();

				void show();
				void hide();
				void speed (int spdX, int spdY);
				void location  (CPoint<int> aLoc);
				void shap (CCursor aCur);

				void HorRang  (int minX, int maxX);
				void VertRang (int minY, int maxY);
				void rect     (CRect<int> aLoc);
				void hiderect (CRect<int> aLoc);

				int buttons () 		{ return newButtons; };
				CPoint<int> location ()  { return msLoc; 	  };
//------------------------------MORE-COOL----------------------------------\\
				int whatnew();
				int whatOn ();
				int whatOff();
				int click();
				int move();
};
//-----------------------------MAIN----------------------------------------\\
CMouse::CMouse()
{
}

int CMouse::init()
{
_AX = 0;
geninterrupt (0x33);
return _AX;
}

void CMouse::show ()
{
_AX = 0x0001;
geninterrupt (0x33);
}

void CMouse::hide ()
{
_AX = 0x0002;
geninterrupt (0x33);
}

void CMouse::myAsk ()
{
oldLoc = msLoc;
oldButtons = newButtons;
_AX = 0x0003;

geninterrupt (0x33);

msLoc.x = _CX;
msLoc.y = _DX;
newButtons = _BX;
}


int CMouse::ask ()
{
myAsk();
if (oldButtons == newButtons) return -1;
else						  return newButtons;
}

void CMouse::location  (CPoint<int> aLoc)
{
_CX   = aLoc.x;
_DX	  = aLoc.y;
_AX   = 0x0004;

geninterrupt (0x33);
}

void CMouse::speed    (int spdX, int spdY)
{
_CX		= spdX;
_DX		= spdY;
_AX		= 0x000f;
geninterrupt (0x33);
}

void CMouse::rect     (CRect<int> aLoc)
{
HorRang  (aLoc.x(), aLoc.x2());
VertRang (aLoc.y(), aLoc.y2());
}

void CMouse::HorRang (int minX, int maxX)
{
_CX		= minX;
_DX		= maxX;
_AX		= 0x0007;
geninterrupt (0x33);
}

void CMouse::VertRang (int minY, int maxY)
{
_CX		= minY;
_DX     = maxY;
_AX     = 0x0008;
geninterrupt (0x33);
}

void CMouse::hiderect (CRect<int> aLoc)
{
_CX		= aLoc.x();
_DX		= aLoc.y();
_SI		= aLoc.x2();
_DI		= aLoc.y2();
_AX 	= 0x0010;
geninterrupt (0x33);
}

void CMouse::shap (CCursor aCur)
{
CPoint<int> aHot = aCur.hotspot();

_BX		= aHot.x;
_CX		= aHot.y;
int *pointer = aCur.mask();
asm mov dx, pointer;
_AX		= 0x0009;
geninterrupt (0x33);
}

//------------------------------MORE-COOL----------------------------------\\
int CMouse::whatnew()
{
return oldButtons ^ newButtons;
}

int CMouse::whatOn()
{
return whatnew() & newButtons;
}

int CMouse::whatOff()
{
return whatnew() & oldButtons;
}

int CMouse::click()
{
static int i = FALSE;
static int firstButton;
static CPoint<int> firstLoc;

int tmp;

if (!i)
	{
	tmp = whatOn();
	if (!tmp) return FALSE;
	firstLoc    = msLoc;
	firstButton = tmp;
	i = TRUE;
	return FALSE;
	}

tmp = whatOff();
if (!tmp) return FALSE;

if (firstButton == tmp && firstLoc == msLoc)
	{
	i = FALSE;
	return tmp;
	}

if (firstButton == tmp && firstLoc != msLoc)
	{
	i = FALSE;
	return FALSE;
	}

return FALSE;
}

int CMouse::move()
{
if (oldLoc == msLoc) return FALSE;
return TRUE;
}
#endif
