#ifndef _COLW_H_
#define _COLW_H_

#include <bios.h>
#include <conio.h>

#include <cmouse.h>
#include <cwindow.h>

#define  WIN32			32
//-------------------COLW--------------------------------------------------
class COLW : public CWindow
{
protected:
				CWindow **myWins;
				CWindow *myPFW;				 		//Previouse Focus Win
				int myNumOfWin;
				int myCounter;
				int myFCounter;
				int myTmpFCount;

				virtual void myGiveFocus (int aNum);
public:
				COLW (CRect<int> aLoc, int aNum);
				COLW();
				virtual ~COLW();
//--------------------------------------------------------------------------
				virtual void draw     ();

				virtual void getFocus ();
				virtual void lostFocus();
				virtual void viewport ();
				virtual void onMouse  (CPoint<int> aLoc);
				virtual void offMouse ();
				virtual void onKbhit  (int aKey);
				virtual  int status   ();
				virtual void status   (int aStat);
//--------------------------------------------------------------------------
				virtual void nextFocus (int aNum = 0);
				virtual int  onCommand (int aCommand);
//--------------------------------------------------------------------------
				virtual CWindow *add (CWindow *aWin);
				virtual void remove  (CWindow *aWin);
				virtual void connectnextlevel();
};
//--------CONSTRUCTORS-------------------------------------------------------
COLW::COLW (CRect<int> aLoc, int aNum)
{
myWins      = (CWindow **) malloc ((sizeof (int*)) * aNum);
myPFW 		= NULL;
myLoc 	    = aLoc;
myNumOfWin  = aNum;
myCounter   = 0;
myFCounter  = 0;
myTmpFCount = 0;
}

COLW::COLW()
{
myWins      = NULL;
myPFW 		= NULL;
myNumOfWin  = 0;
myCounter   = 0;
myFCounter  = 0;
myTmpFCount = 0;
}

COLW::~COLW ()
{
for (int i = 0; i < myCounter; i++)	delete myWins[i];
}

//------------FUNCTIONS------------------------------------------------------

CWindow *COLW::add (CWindow *aWin)
{
if (!aWin) { printf ("Not enough memory or trying to add NULL\n"); abort(); }
if (myCounter >= myNumOfWin) return NULL;
//aWin->parent (this);
myWins [myCounter++] = aWin;
//connectnextlevel();
return aWin;
}

void COLW::connectnextlevel()
{
for (int i = 0; i < myCounter; i++)
	{
	if (!myWins[i]) continue;
	myWins[i]->dc     (myDc);
	myWins[i]->parent (this);
	myWins[i]->mouse  (myMouse);
	myWins[i]->connectnextlevel();
	}
}

void COLW::status (int aStat)
{
myStatus = aStat;
}

int COLW::status()
{
return myStatus;
}

void COLW::remove (CWindow *aWin)
{
for (int i = 0; i < myCounter; i++)
	if (myWins[i] == aWin)
		{
		myWins[i]->status (HIDE);
		if (myFCounter-- == i) myWins[i]->lostFocus();
		for (int q = i; q < myCounter - 1; i++)	myWins[i] = myWins[i + 1];
		myCounter--;
		nextFocus();
		break;
		}
}

void COLW::onMouse (CPoint<int> aLoc)
{
CWindow *aP = myPFW;
aLoc -= CPoint<int> (myLoc.x(), myLoc.y());
for (int i = 0; i < myCounter; i++)
	if (myWins[i]->contain (aLoc))
		if (myWins[i]->status() != HIDE)
			{
			if (myMouse->whatOn() == LEFTB) myGiveFocus(i);
			myWins[i]->onMouse (aLoc);
			if (myPFW == myWins[i]) aP 	  = NULL;
			else 				    myPFW = myWins[i];
			}
		else continue;
if (aP) { myPFW = NULL; aP->offMouse(); }
}

void COLW::offMouse ()
{
onMouse (CPoint<int> (myLoc.x() + myLoc.width() + 1,    //grubo
					  myLoc.y() + myLoc.height() + 1)); //otstoy
}

void COLW::onKbhit (int aKey)
{
if (!myCounter) return;
//if (aKey == TAB) nextFocus();
if (myWins[myFCounter]->status() != HIDE &&
	myWins[myFCounter]->enableFocus()) myWins[myFCounter]->onKbhit (aKey);
}

void COLW::viewport()
{
if (myPar) myPar->viewport();
myDc->addviewport (myLoc);
}
//-------------------------PROTECTED-----------------------------------------
void COLW::myGiveFocus (int aNum)
{
if (myWins[aNum]->enableFocus() && aNum != myFCounter)
	{
	if (myWins[myFCounter]->status()) myWins[myFCounter]->lostFocus();
	myFCounter = aNum;
	myWins[myFCounter]->getFocus();
	}
}

//------------FUNCTIONS------------------------------------------------------
void COLW::nextFocus (int aNum)
{
int aTmp = myFCounter + 1 + aNum;
if (!myCounter) return;
if (aTmp >= myCounter) aTmp = 0;
if (aTmp < 0) 		   aTmp = myCounter - 1;
if (myWins[aTmp]->status() == HIDE || !myWins[aTmp]->enableFocus())
	{
	if (myTmpFCount++ >= myCounter) return;
	nextFocus (myTmpFCount);
	return;
	}
myTmpFCount = 0;
myGiveFocus (aTmp);
}

int COLW::onCommand (int aCommand)
{
return aCommand++;
}

//---------------------------------------------------------------------------
void COLW::draw()
{
myMouse->hide();
if (myPar) myPar->viewport();
myDc->rect3d (myLoc, myStatus);
if (myStatus != HIDE)
	{
	for (int i = 0; i < myCounter; i++) myWins[i]->draw();
	if (myCounter) myWins[myFCounter]->getFocus();
	}
myMouse->show();
}

void COLW::getFocus()
{
}

void COLW::lostFocus()
{
}
//---------------------------------------------------------------------------
#endif


