#ifndef __CPALITRA_H__
#define __CPALITRA_H__

#include <cbutton.h>


class CPalitra: public CButton
{
protected:
				int myColNum;
				int myColor;
				int myColW;

				void (*myChCol) (CPalitra *p);

				virtual void click    (int aStat, CPoint<int> aLoc);
				virtual void newcolor (int aNum);
public:
				CPalitra (CRect<int> aLoc, int aNumCol,
							  void (*aP) (CPalitra *b));
				CPalitra ();

				virtual ~CPalitra    ();

				virtual void draw    ();
				virtual int  getcolor();
};

CPalitra::CPalitra (CRect<int> aLoc, int aNumCol, void (*aP) (CPalitra *b)):
CButton (aLoc, "")
{
myChCol  = aP;
myColNum = aNumCol;
myColor  = BLACK;
myColW   = myLoc.width() / myColNum;
}

CPalitra::CPalitra()
{
myChCol  = NULL;
myColNum = 16;
myColor  = BLACK;
}

CPalitra::~CPalitra()
{
}

void CPalitra::draw()
{
if (!myDc) return;
myMouse->hide();
viewport();
myDc->rect3d (myLoc, PRESS);
for (int i = 0; i < myColNum; i++)
	myDc->rect3d (CRect<int> (myLoc.x() + myColW * i + 1, myLoc.y() + 1,
							  myColW - 2, myLoc.height() - 2), UNPRESS, i);
myMouse->show();
}

void CPalitra::click (int aStat, CPoint<int> aLoc)
{
aLoc++;
if (aStat == FALSE)
	if (myStatus != UNPRESS) myClickStat = FALSE;

if (myMouse->whatOn() == LEFTB && !myClickStat)
	myClickStat = TRUE;

if (myMouse->whatOff() == LEFTB && myClickStat == TRUE)
	{
	myClickStat = FALSE;
	newcolor ((aLoc.x - myLoc.x()) / myColW);
	}
}

void CPalitra::newcolor (int aNum)
{
myMouse->hide();
myDc->addviewport (myLoc);
myDc->rect3d (CRect<int> (myColW * myColor + 1, 1,
						  myColW - 2, myLoc.height() - 2), UNPRESS, myColor);
myColor = aNum;

myDc->rect3d (CRect<int> (myColW * aNum + 1, 1,
						  myColW - 2, myLoc.height() - 2), PRESS, aNum);
myMouse->show();
if (myChCol) (*myChCol) (this);
}

int CPalitra::getcolor()
{
return myColor;
}

#endif