#ifndef __CPARK_H__
#define __CPARK_H__

#include <ccarmask.h>

#define             NUMBER_IN_PARKING         16

class CPark
{
protected:
				CRect<int> myLoc;
				CCarMask **myMasks;
				int        myCurCar;
				int        myBkCol;
public:
				CPark (CRect<int> aLoc, int aBk);
				CPark ();
				virtual ~CPark();

				virtual void addcar (CCarMask *aMask);
};


CPark::CPark (CRect<int> aLoc, int aBk)
{
myBkCol  = aBk;
myCurCar = 0;
myLoc    = aLoc;
myMasks  = (CCarMask **) malloc (sizeof (CCarMask **) * NUMBER_IN_PARKING);
assert (myMasks);
}


CPark::CPark()
{
myBkCol  = BLACK;
myCurCar = 0;
myLoc    = (CRect<int> (10, 10, 600, 25));
myMasks  = (CCarMask **) malloc (sizeof (CCarMask **) * NUMBER_IN_PARKING);
assert (myMasks);
}

CPark::~CPark()
{
free (myMasks);
}


void CPark::addcar (CCarMask *aMask)
{
if (myCurCar < NUMBER_IN_PARKING) myMasks [myCurCar++] = aMask;
if (myCurCar >= NUMBER_IN_PARKING)
	{
	for (int i = 0; i < myCurCar; i++)
		myMask[i]->draw (CPoint<float> (myLoc.x() + i * 20,
						  myLoc.y() + myLoc.height() / 2), HIDE, myBkCol);
	for (i = 0; i < myCurCar - 1; i++)
		myMasks[i] = myMasks[i+1];
	myMasks[--myCurCar] = aMask;
	}

aMask->draw (CPoint<float> (myLoc.x() + myCurCar * 20,
						 myLoc.y() + myLoc.height() / 2), DRAW, myBkCol);
}

#endif