#ifndef _CSCREEN_H_
#define _CSCREEN_H_

#include <crect.h>
class CScreen
{
protected:
					int 	   myFrontcolor;
					int 	   myBackcolor;
					int 	   myFillstyle;
					int 	   myFont;
					int 	   myFontSize;
					CRect<int> mySavedVP;

public:
					virtual ~CScreen() {};

					virtual int frontcolor	() = 0;
					virtual int backcolor	() = 0;
					virtual void frontcolor	(int aColor) = 0;
					virtual void backcolor	(int aColor) = 0;

					virtual int  font		()  = 0;
					virtual int  fontsize	()  = 0;
					virtual void font		(int aFont)  = 0;
					virtual void fontsize	(int aSize)  = 0;

					virtual int  widthoftext	(char *aStr) = 0;
					virtual int  heightoftext	(char *aStr) = 0;

					virtual void point 	  	(CPoint<int>  aLoc,
											 int aFrontcolor = NON) = 0;

					virtual void Line 	  	(CRect<int>  aLoc,
											 int aFrontcolor = NON) = 0;

					virtual void rect 	    (CRect<int>  aLoc,
											 int aBackcolor = NON,
											 int aFrontcolor = NON) = 0;

					virtual void text 	    (CPoint<int>  aLoc,
											 char *aText,
											 int aFrontcolor = NON,
											 int aBackcolor = NON) = 0;

					virtual void rect3d (CRect<int>  aLoc, int status,
										 int aColor = NON) = 0;

					virtual void fillstyle (int aPattern = SOLID_FILL,
											int aColor = LIGHTGRAY) = 0;

					virtual void fillback (int aBackcolor = LIGHTGRAY) = 0;

					virtual void textstyle (int aFont = DEFAULT_FONT,
											int aSize = 1) = 0;

					virtual int maxx() = 0;
					virtual int maxy() = 0;
					virtual int maxz() = 0;

					virtual void viewport (CRect<int>  aLoc = FULL,
										   int aClip = TRUE) = 0;

					virtual void saveviewport() = 0;
					virtual void loadviewport() = 0;
					virtual void addviewport (CRect<int> aLoc)  = 0;
					virtual CRect<int> getviewport () = 0;

					virtual void clip (int aClip) = 0;
};
#endif
