#ifndef _CSTDOLW_H_
#define _CSTDOLW_H_

#include <colw.h>
#include <clabel.h>
#include <closebut.h>
//---------------------------------------------------------------------------
void CSTDOLW_BUTTON_CLOSE (CButton *b);
//------------CSTDOLW--------------------------------------------------------
class CSTDOLW: public COLW
{
protected:
			 void (*myCloseP)(CSTDOLW *w);
			 CLabel *myLabel;
public:
			 CSTDOLW (CRect<int> aLoc, char *aCap = "WINDOW",
				void (*aCloseP)(CSTDOLW *w) = NULL, int aStat = UNPRESS);

			 virtual void close    ();
			 virtual void open     ();
			 virtual void caption  (char *aCap);

			 virtual void getFocus ();
			 virtual void lostFocus();
};
//---------------------------------------------------------------------------
CSTDOLW::CSTDOLW (CRect<int> aLoc, char *aCap, void (*aCloseP)(CSTDOLW *w),
																int aStat):
COLW (aLoc, WIN32)
{
myStatus = aStat;
myLabel = (CLabel *) add (new CLabel (CRect<int> (3, 3, aLoc.width() - 6, 15),
													  aCap, DARKGRAY, WHITE));
add (new CCloseButton (CRect<int> (aLoc.width() - 15, 6, 9, 9),
												CSTDOLW_BUTTON_CLOSE));
myCloseP = aCloseP;
}

void CSTDOLW::close()
{
parent()->closewindow (this);
if (myCloseP) (*myCloseP)(this);
}

void CSTDOLW::open()
{
parent()->openwindow (this);
}

void CSTDOLW::getFocus()
{
myMouse->hide();
if (myPar) myPar->viewport();
myLabel->color (BLUE);
myWins[1]->draw();
if (myCounter) myWins[myFCounter]->getFocus();
myMouse->show();
}

void CSTDOLW::lostFocus()
{
myMouse->hide();
if (myPar) myPar->viewport();
myLabel->color (DARKGRAY);
myWins[1]->draw();
if (myCounter) myWins[myFCounter]->lostFocus();
myMouse->show();
}

void CSTDOLW::caption (char *aCap)
{
myLabel->caption (aCap);
}
//---------------------------------------------------------------------------
void CSTDOLW_BUTTON_CLOSE (CButton *b)
{
b->parent()->close();
//b++;
}

//---------------------------------------------------------------------------
#endif