#ifndef _CEDITTXT_H_
#define _CEDITTXT_H_

#include <dos.h>
#include <bios.h>
#include <string.h>						// - ᠬ ப 㪢
#include <conio.h>
#include <stdlib.h>
#include <assert.h>

#include <cwindow.h>
#include <cmouse.h>
#include <defines.h>
#include <crect.h>
#include <cbgi.h>
#include <keys.h>

#define				TEXT_LONG				32
//----------CLASS---CText---------------------------------------------------
class CText: public CWindow
{
protected:		char veryold [TEXT_LONG + 1];
				char oldText [TEXT_LONG + 1];
				char newText [TEXT_LONG + 1];
				int myIns;
				int myPos;
				int myFont;
				int myFontSize;
				int myWidth;
				int myHeight;
				int myLong;
				int myShift;

				virtual void drawcurs (int aPos = NON);
				virtual void hidecurs (int aPos = NON);
				virtual void del();
				virtual void backspace();
				virtual void print (int aBuf = TRUE);
				virtual void myBufprint();
				virtual void newinput (int newKey);
				virtual void home();
				virtual void end();
				virtual void left();
				virtual void right();
				virtual void esc();
				virtual void enter();

				virtual int myEdit (int newKey);

				void (*myInputP)(CText *t);

public:
				CText (CRect<int> aLoc, char *aText,
					int aFont = DEFAULT_FONT, int aSize = 1,
					void (*aInputP)(CText *t) = NULL);

				virtual ~CText();

				virtual char *edit ();
				virtual void  text (char *aText, int aDraw = TRUE);
				virtual char *text ();

//---------------PURE---VIRTUALE-------------------------------------------
				virtual void draw();
				virtual void onMouse  (CPoint<int> aLoc);
				virtual void offMouse ();
				virtual void onKbhit  (int aKey);
				virtual void getFocus ();
				virtual void lostFocus();
				virtual void viewport ();
//----------------PURE---VIRTUALE-------------------------------------------
};
//-----------------CONSTRUCTORS----------------------------------------------
CText::CText (CRect<int> aLoc, char *aText, int aFont, int aSize,
									  void (*aInputP)(CText *t))
{
for (int i = 0; i <= TEXT_LONG; i++) newText[i] = '\0';
for (i = 0; i <= TEXT_LONG; i++) oldText[i] = '\0';
for (i = 0; i <= TEXT_LONG; i++) veryold[i] = '\0';
strcpy (newText, aText);
strcpy (veryold, aText);
myDc       = NULL;
myInputP   = aInputP;
myIns 	   = 0;
myShift    = 0;
myLoc  	   = aLoc;
myFont     = aFont;
myFontSize = aSize;
myLong	   = strlen (aText);
myPos	   = myLong;
myWidth    = textwidth  ("A");
myHeight   = textheight ("A");
}

CText::~CText()
{
}
//--------------FUNCTIONS----------------------------------------------------
void CText::draw()
{
if (!myDc) return;
myMouse->hide();
viewport();
if (myStatus == HIDE)
	{
	myDc->rect3d (myLoc, HIDE);
	myMouse->show();
	return;
	}
myDc->rect3d (myLoc, PRESS, WHITE);
print (FALSE);
myMouse->show();
}

void CText::print (int aBuf)
{
if (!myDc) return;
myMouse->hide();
viewport();
myDc->addviewport (myLoc);
myDc->textstyle   (myFont, myFontSize);
if (aBuf) myBufprint();
else															// ??
	{                                                           // ??
	char tmp[2] = "";                                           // ??
	for (int i = 0; i < TEXT_LONG; i++)                         // !!
		{                                                       // !!
		tmp[0] = newText[i];                                    // !!
		myDc->text (CPoint<int> (3 + i * myWidth, 3), tmp, BLACK);// !!
		}                                                       //  !!
//	myDc->text (CPoint<int> (3, 3), newText, BLACK);            //  !!
	}                                                           //  !!
myMouse->show();
}

void CText::myBufprint()
{
char tmp[2] = "";
for (int i = 0; i < TEXT_LONG; i++)
	{
	if (newText[i] == oldText[i]) continue;
	tmp[0] = oldText[i];
	myDc->text (CPoint<int> (3 + i * myWidth, 3), tmp, WHITE);
	tmp[0] = newText[i];
	myDc->text (CPoint<int> (3 + i * myWidth, 3), tmp, BLACK);
	}
}

void CText::newinput (int newKey)
{
if (myPos == TEXT_LONG) return;
strcpy (oldText, newText);
hidecurs();
if (myIns) newText[myPos++] = newKey & 0xFF;
else
	{
	if (myLong == TEXT_LONG) { drawcurs(); return; }
	char work[TEXT_LONG];
	for (int i = 0; i < TEXT_LONG - myPos; i++) work[i] = newText[myPos + i];
	newText[myPos++] = newKey & 0xFF;
	for (i = 0; i < TEXT_LONG - myPos; i++) newText[myPos + i] = work[i];
	}
drawcurs();
print();
}

//------------------EDIT---------------------------------------------------
char *CText::edit()
{
while (TRUE)
	{
	int key = myEdit (bioskey(0));
	if (key == ESC)   return veryold;
	if (key == ENTER) return newText;
	}
}

void CText::text (char *aText, int aDraw)
{
for (int i = 0; i <= TEXT_LONG; i++) newText[i] = '\0';
for (i = 0; i <= TEXT_LONG; i++) oldText[i] = '\0';
strcpy (newText, aText);
strcpy (veryold, aText);
myLong = strlen (aText);
myPos  = myLong;
if (aDraw == FALSE) return;
draw();
}

char *CText::text()
{
return newText;
}


int CText::myEdit (int newKey)
{
assert (myPos >= 0 && myPos <= TEXT_LONG);
myLong = strlen (newText);

myShift = bioskey(2) & 0x03; //...000011;
if ((newKey >> 8) >= 0x3B && (newKey >> 8) <= 0x46) return NON;//!!F1 - F12
switch (newKey)
	{
	case ESC:  		esc();   return ESC;
	case ENTER:     enter(); return ENTER;
	case PUP:		return NON;
	case PDOWN:     return NON;
	case UP:   		return NON;
	case DOWN: 		return NON;
	case TAB:       return NON;
	case INS:  		myIns = !myIns; 	return NON;
	case BACKSPACE: backspace(); 		return NON;
	case DEL:		del(); 				return NON;
	case HOME:      home();             return NON;
	case END:		end();              return NON;
	case LEFT:      left(); 			return NON;
	case RIGHT:     right();			return NON;
	}
newinput (newKey);
return newKey;
}
//------------------DELL'y---------------------------------------------------
void CText::del()
{
strcpy (oldText, newText);
hidecurs();
for (int i = myPos; i < TEXT_LONG; i++) newText[i] = newText[i + 1];
drawcurs();
print();
}

void CText::backspace()
{
if (!myPos) return;
strcpy (oldText, newText);
hidecurs();
for (int i = --myPos; i < TEXT_LONG; i++) newText[i] = newText[i + 1];
drawcurs();
print();
}

void CText::home()
{
hidecurs();
myPos = 0;
drawcurs();
}

void CText::end()
{
hidecurs();
myPos = myLong;
drawcurs();
}

void CText::right()
{
if (myPos == TEXT_LONG || myPos + 1 > myLong) return;
hidecurs();
myPos++;
drawcurs();
}

void CText::left()
{
if (!myPos) return;
if (myShift);
hidecurs();
myPos--;
drawcurs();
}

void CText::esc()
{
for (int i = 0; i <= TEXT_LONG; i++) newText[i] = '\0';
strcpy (newText, veryold);
myLong	= strlen (newText);
myPos	= myLong;
draw();
drawcurs();
}

void CText::enter()
{
strcpy (veryold, newText);
hidecurs();
if (myInputP) (*myInputP)(this);
}
//-------------------------CURSOR--------------------------------------------
void CText::drawcurs (int aPos)
{
if (!myDc) return;
if (aPos > myLong) return;
if (aPos == NON) aPos = myPos;
myMouse->hide();
viewport();
myDc->addviewport (myLoc);
myDc->rect (CRect<int> (aPos * myWidth + 1, 6 + myHeight, myWidth, 0),
														  NON, BLACK);
myMouse->show();
}

void CText::hidecurs (int aPos)
{
if (!myDc) return;
if (aPos == NON) aPos = myPos;
myMouse->hide();
viewport();
myDc->addviewport (myLoc);
myDc->rect (CRect<int> (aPos * myWidth + 1, 6 + myHeight, myWidth, 0),
														  NON, WHITE);
myMouse->show();
}

//---------------PURE---VIRTUALE-------------------------------------------
void CText::onMouse (CPoint<int> aLoc)
{
aLoc = aLoc;
}

void CText::offMouse()
{
}

void CText::onKbhit (int aKey)
{
myEdit (aKey);
}

void CText::getFocus()
{
if (!myDc) return;
myMouse->hide();
drawcurs();
viewport();
myDc->rect (myLoc.grow (1), NON, BLACK);
myMouse->show();
}

void CText::lostFocus()
{
if (!myDc) return;
//for (int i = 0; i <= TEXT_LONG; i++) newText[i] = '\0';
//strcpy (newText, veryold);
//myLong	= strlen (newText);
//myPos	= myLong;

myMouse->hide();
//hidecurs();
//draw();
viewport();
myDc->rect (myLoc.grow (1), NON, LIGHTGRAY);
myMouse->show();
}

void CText::viewport()
{
if (myPar) myPar->viewport();
}


#endif
