#ifndef _CWINDOW_H_
#define _CWINDOW_H_

#include <cmouse.h>
#include <keys.h>
#include <crect.h>
#include <cbgi.h>

//----------------------COMMANDS--------------------------------------------
#define 				NEW_CWINDOW			0x00

//-------------------CWINDOW------------------------------------------------
class CWindow
{
protected:
				CWindow *myPar;
				CScreen *myDc;
				CMouse  *myMouse;
				CRect<int> myLoc;
				int myEnableFocus;
				int myStatus;

public:         CWindow ();
				virtual ~CWindow ();
//--------------------------------------------------------------------------
				virtual void onMouse  (CPoint<int> aLoc) = 0;
				virtual void offMouse () = 0;
				virtual void onKbhit  (int aKey) = 0;

				virtual void draw     () = 0;

				virtual void getFocus () = 0;
				virtual void lostFocus() = 0;
				virtual void viewport () = 0;
//--------------------------------------------------------------------------
				virtual void dc		  (CScreen *aDc);
				virtual void mouse	  (CMouse  *aMs);


				virtual void       location   (CRect<int> aLoc);
				virtual CRect<int> location   ();
				virtual int        status     ();
				virtual void       status     (int aStat);
				virtual void       parent 	  (CWindow *w);
				virtual CWindow   *parent 	  ();
				virtual int        contain 	  (CPoint<int> aLoc);
				virtual int        enableFocus();

				virtual void connectnextlevel ();
				virtual void        nextFocus (int aNum = 0);
				virtual int         onCommand (int aCommand);
				virtual void        close();
				virtual void        open();
				virtual void        closewindow (CWindow *aWin);
				virtual void        openwindow  (CWindow *aWin);
};
//---------------------------------------------------------------------------
CWindow::CWindow():
myLoc()
{
myStatus = UNPRESS;
myPar    = NULL;
myDc     = NULL;
myMouse  = NULL;
myEnableFocus = TRUE;
}

CWindow::~CWindow()
{
}

int CWindow::status()
{
return myStatus;
}

void CWindow::status (int aStat)
{
myStatus = aStat;
draw();
}

void CWindow::parent (CWindow *w)
{
myPar = w;
}

CWindow *CWindow::parent()
{
return myPar;
}

int CWindow::contain (CPoint<int> aLoc)
{
return myLoc.contain (aLoc);
}

void CWindow::location (CRect<int> aLoc)
{
myLoc = aLoc;
}

CRect<int> CWindow::location ()
{
return myLoc;
}

void CWindow::dc (CScreen *aDc)
{
if (!aDc) return;
myDc = aDc;
}

void CWindow::mouse (CMouse *aMs)
{
if (!aMs) return;
myMouse = aMs;
}

int CWindow::enableFocus()
{
return myEnableFocus;
}

void CWindow::nextFocus (int aNum)
{
aNum++;
}

void CWindow::connectnextlevel()
{
}

void CWindow::close()
{
}

void CWindow::open()
{
}

void CWindow::closewindow (CWindow *aWin)
{
aWin++;
}

void CWindow::openwindow (CWindow *aWin)
{
aWin++;
}

int CWindow::onCommand (int aCommand)
{
return aCommand++;
}
#endif
