#ifndef __CWMM_H_
#define __CWMM_H_

#include <colw.h>
//-----------------------------CWindowsMainManager---------------------------
class CWMM: public COLW
{
protected:      void (*myInitFunction)();

				virtual void myNewFocus();

//---------------VARIABLES--------------------------------------------------
				int running;

public:
//--------------------------------------------------------------------------
				CWMM (CScreen *aDc, CMouse *aMs, void (*aInit)() = NULL);
				CWMM();
				virtual ~CWMM();
//----------------------PURE-VIRTUAL-FUNCTIONS------------------------------
				virtual void draw     ();
				virtual void getFocus ();
				virtual void lostFocus();
				virtual void viewport ();
//---------------------------MANEGMENT--------------------------------------
				virtual int  run();
				virtual int  onCommand (int aCommand);
				virtual void onKbhit   (int aKey);
				virtual void offMouse();
				virtual void close();
				virtual void closewindow (CWindow *aWin);
				virtual void openwindow  (CWindow *aWin);
//--------------------------------------------------------------------------
};

//------------------CONSTRUCTORS--------------------------------------------
CWMM::CWMM (CScreen *aDc, CMouse *aMs, void (*aInit)()):
COLW (NULL, WIN32)
{
myInitFunction = aInit;
if (!aDc) { printf ("There is no Video system\n"); abort(); }
if (!aDc) { printf ("There is no Mouse system\n"); abort(); }
myDc    = aDc;
myMouse = aMs;
myPar   = NULL;
running = FALSE;
myMouse->init();
myMouse->show();
}

CWMM::CWMM()
{
myDc    = NULL;
myMouse = NULL;
myPar   = NULL;
running = FALSE;
}

CWMM::~CWMM()
{
delete myDc;
delete myMouse;
}

void CWMM::draw()
{
myMouse->hide();
myDc->fillback();
for (int i = 0; i < myCounter; i++) myWins[i]->draw();
myMouse->show();
}
//------------------EMPTY---------------------------------------------------
void CWMM::getFocus()
{
}

void CWMM::lostFocus()
{
}

void CWMM::offMouse()
{
}

void CWMM::viewport()
{
myDc->viewport();
}
//------------------RUNNING-------------------------------------------------
int CWMM::run ()
{
connectnextlevel();
if (myInitFunction) myInitFunction();
draw();
if (myCounter) myNewFocus();
running = TRUE;
while (TRUE)
	{
	myMouse->ask();
	if (myMouse->whatnew() || myMouse->move())
			onMouse (myMouse->location());
	if (kbhit()) onKbhit (bioskey(0));
	if (!running) return TRUE;
	}
}

void CWMM::onKbhit (int aKey)
{
if (aKey == F9)	 close();//running = FALSE;
if (!myCounter) return;
if (aKey == F10) nextFocus();
if (myWins[myFCounter]->status() != HIDE &&
	myWins[myFCounter]->enableFocus()) myWins[myFCounter]->onKbhit (aKey);
}

int CWMM::onCommand (int aCommand)
{
switch (aCommand)
	{
	case NEW_CWINDOW:
		if (running) return TRUE;
		else         return FALSE;
	}
return FALSE;
}

void CWMM::myNewFocus()
{
while (TRUE)
	{
	if (myWins[myFCounter]->enableFocus() &&
		myWins[myFCounter]->status() != HIDE)
		{
		myWins[myFCounter]->getFocus();
		return;
		}
	if (myFCounter >= myCounter - 1) return;
	else myFCounter++;
	}
}

void CWMM::close()
{
running = FALSE;
}

void CWMM::closewindow (CWindow *aWin)
{
viewport();
for (int i = 0; i < myCounter; i++)
	if (myWins[i] == aWin)
		{
		myWins[i]->status (HIDE);
		break;
		}
draw();
//nextFocus();
}

void CWMM::openwindow (CWindow *aWin)
{
myDc->viewport();
for (int i = 0; i < myCounter; i++)
	if (myWins[i] == aWin)
		{
		myWins[i]->status (OPEN);
		myWins[i]->draw();
		myGiveFocus(i);
		break;
		}
}

//--------------------------------------------------------------------------
#endif